# COMPSCI 365
# Spring 2020
# YOUR NAME HERE
# Assignment 5: FAT16 Parsing

# Complete the relevant functions.
# Make sure to test your implementations.
# You can import any standard library.
# You can define any new function you want.

def readSectors(sample, startSec, endSec):
    return open(sample, "rb").read()[512*startSec:512*endSec]

def boot_sector_info(inputFile):
    """
    Description: Read the given input file (assuming it is an image of a
    FAT16 filesystem), and extract the following information from the FAT16 boot sector
    (you can assume that ALL of these exist):

    - OEM Name (string)
    - Boot Sector Signature (bytes object)
    - Logical Sector Size in bytes (integer)
    - Sectors per Cluster (integer)
    - Cluster Size in bytes (integer)
    - Number of Reserved Sectors (integer)
    - Number of FATs (integer)
    - Maximum Number of Root Directories (integer)
    - Total Logical Sectors (integer) - careful offset 0x13 vs 0x20
    - Sectors per FAT (integer)
    - Volume ID (bytes object)
    - Volume Label (string)
    - FS Type Label (string)

    The input file will be given as a string filename, so you must
    open it and read it. Return the above information with the above
    given types in the following ordered list format:

    [ oem name string, boot sector signature bytes, logical sector size integer, ..., fs type label string ]

    EX:

    boot_sector_info("samples/fat16fs.img") = ["mkfs.fat", b'\x55\xaa', 512, 4, 2048,
    1, 2, 64, 24576, 24, b'\x1f\x37\x31\x74', "CS365      ", "FAT16   "]

    """
    pass

def read_chain(fatTableBytes, startCluster):
    """
    Description: Given the input FAT table bytes object, and a starting cluster integer
    (indexed from 0), read the chain of FAT table entries until a EOF marker is encountered.
    Then, return the chain of cluster numbers as an ordered list of integers.

    Remember, the chain may not be in order (ex. [20, 42, 13, 49]).

    EX:

    read_chain(readSectors("samples/fat16fs_subdir.img", 1, 25), 18) = [18, 19, 20]
    read_chain(readSectors("samples/fat16fs_subdir.img", 1, 25), 27) = [27]
    read_chain(readSectors("samples/fat16fs_subdir.img", 1, 25), 9) = [9]
    read_chain(readSectors("samples/fat16fs_subdir.img", 1, 25), 44) = [44, 45, 46, 47, 48, 49]

    """
    pass

def directory_info(directoryBytes):
    """
    Description: Read the given bytes object, which contains a sequence of directory entries (32B each),
    and extract the directory entries. You should continue extracting directory entries until
    you encounter an entry that starts with a null byte (0x00) or the end of the bytes object.

    You should only parse the directory entry IF all of the following apply:
    (1) The directory entry type is marked as a subdirectory or archive (don't handle LFNs),
    (2) the entry doesn't start with 0xe5 (previously deleted entry),
    (3) the entry doesn't start with 0x7e ("dot" entry).

    Return the following information on each directory in an ordered list of tuples (list order
    is the linear ordering in the "directory entry table"), where each directory is one tuple containing:

    - Short File Name (string)
    - Short File Extension (string)
    - File Attributes Byte (integer)
    - Starting Cluster Number (integer)
    - File Size in Bytes (integer)

    EX:

    directory_info(readSectors("samples/fat16fs.img", 49, 53)) = [
    ("FILE1   ", "   ", 0x20, 9, 48),
    ("FILE2   ", "   ", 0x20, 18, 5660),
    ("FILE3   ", "   ", 0x20, 27, 96)
    ]

    directory_info(readSectors("samples/fat16fs_subdir.img", 49, 53)) = [
    ("FILE1   ", "   ", 0x20, 9, 48),
    ("FILE2   ", "   ", 0x20, 18, 5660),
    ("FILE3   ", "   ", 0x20, 27, 96),
    ("PRIVATE ", "   ", 0x10, 3, 0)
    ]

    directory_info(readSectors("samples/fat16fs_subdir.img", 57, 61)) = [
    ("PDIR    ", "   ", 0x10, 50, 0),
    ("PFILE1  ", "   ", 0x20, 6, 56)
    ]

    directory_info(readSectors("samples/fat16fs_subdir.img", 245, 246)) = [
    ("PFILE2  ", "   ", 0x20, 44, 10711)
    ]

    """

def fat16_parse(inputFile): # BONUS
    """
    **BONUS QUESTION: 20 POINTS**
    Description: Read the given input file (where inputFile is given as a string filename),
    and recursively extract all directory entries using the directory_info function
    you previously completed.

    Return the directory entries in a list of lists, where each inner list is an output
    list from the directory_info function on one of the directories stored in the
    FAT16 FS (including the root directory). This list order does not matter (so you can
    do breadth-first or depth-first, whichever you prefer).

    EX:

    fat16_parse("samples/fat16fs_subdir.img") = [
        [("FILE1   ", "   ", 0x20, 9, 48), ("FILE2   ", "   ", 0x20, 18, 5660), ("FILE3   ", "   ", 0x20, 27, 96), ("PRIVATE ", "   ", 0x10, 3, 0)],
        [("PDIR    ", "   ", 0x10, 50, 0), ("PFILE1  ", "   ", 0x20, 6, 56)],
        [("PFILE2  ", "   ", 0x20, 44, 10711)]
    ]
    """
    return "Not implemented"

def fragmented_score(inputFile, cost=5): # BONUS
    """
    **BONUS QUESTION: 15 POINTS**
    Description: Read the given input file (where inputFile is given as a string filename),
    and parse the FAT table to obtain all of the cluster chains. For each cluster chain, do
    the following for each two sequence pairs of clusters A and B:

    (1) Get the number of clusters distance between A and B and subtract by 1 (ex. [49, 50] = 0),
    (2) Add that value to a running sum of cluster distances.

    Then, multiply the running sum by the cost value, and divide by the total size
    of the filesystem in bytes (i.e. = sector size * number of sectors; both from boot sector).
    Return that final value as the fragmented score.

    Remember to be careful with distances - something like [50, 20, 32] is possible.

    EX:

    fragmented_score("samples/fat16fs.img") = 0
    fragmented_score("samples/fat16fs_frag1.img") = (3 * 5) / (24576 * 512)
    fragmented_score("samples/fat16fs_frag2.img", 85) = (12823 * 85) / (24576 * 512)
    """
    return "Not implemented"
